# Contributing to `universum`

## :wave: Greetings Traveler!

I'm glad you're reading this, I really appreciate the effort you're
putting in. Thank you for your help in making this library awesome! :sparkles:

### How to contribute

#### Report bugs or feature request
If you have found any bugs or have proposals on how to make this project better,
don't hesitate to create issues
[here](https://github.com/serokell/universum/issues/new) in free format.

#### Create a PR
We love receiving pull requests from everyone. But, please, don't create a PR
without a corresponding issue. It's always better to discuss your future
work first. Even if such an issue exist it's still better to express your willing
to do that issue under comment section. Thus you will show that you're doing
that issue, and nobody else will accidentally do it in parallel with you. Furthermore you
also can discuss the best way to implement that issue!

To get started with this you should first fork, then clone the repo:

    git clone git@github.com:your-username/universum.git

Make your changes and consider the following check list to go through before submitting your pull request.

#### :white_check_mark: Check list
- [ ] Project compiles
- [ ] New/fixed features work as expected
- [ ] Old features do not break after the change
- [ ] _Recommended:_ Commit messages are in the proper format. If the commit
  addresses an issue start the first line of the commit with the issue number in
  square parentheses.
  + **_Example:_** `[#42] Short commit description`

If you fix bugs or add new features, please add tests.

After everything above is done, commit and push to your fork.
Now you are ready to [submit a pull request][pr]!

----------
Thanks for spending time on reading this contributing guide! :sparkling_heart:

[pr]: https://github.com/serokell/universum/compare/
